#include <stdlib.h>
#include <stdarg.h>
#include "mmalloc.h"

int mmalloc (int numptrs, ...)
{
   int i, j;
   va_list ap;
   void **p;
   size_t s;
   
   va_start (ap, numptrs);
   for (i = 0; i < numptrs; ++i) {
      p = va_arg (ap, void**);
      s = va_arg (ap, size_t);
      *p = malloc (s);
      if (*p == NULL) {
         /* Then free up what we did so far */
         va_start (ap, numptrs);
         for (j = 0; j <= i; ++j) {
            p = va_arg (ap, void**);
            va_arg (ap, size_t);
            free (*p);
            *p = NULL;
         }
         /* then keep working to set the rest to NULL */
         for (; j < numptrs; ++j) {
            p = va_arg (ap, void**);
            va_arg (ap, size_t);
            *p = NULL;
         }
         /* and return failure */
         va_end (ap);
         return -1;
      }
   }
   va_end (ap);
   return 0;
}

void mfree (int numptrs, ...)
{
   int i;
   va_list ap;
   void *p;
   
   va_start (ap, numptrs);
   for (i = 0; i < numptrs; ++i) {
      p = va_arg (ap, void*);
      free (p);
   }
   va_end (ap);
}
