#ifdef MMALLOC_H
#else
#define MMALLOC_H

/* mmalloc (n, type1** pp1, size_t size1, type2** pp2, size_t size2, ...);
* Returns 0 if size1 memory is successfully malloc'ed in *pp1, size2
* memory is successfully malloc'ed in *pp2, etc.
* Returns -1 if any of the allocations failed, and frees up those that
* did (setting the pointers *pp1, *pp2, ... to NULL), or if any of pp1, pp2,
* etc. are NULL.
*/
int mmalloc (int numptrs, ...);

/* mfree (p1, p2, ...);
* Calls free for each of the given pointers.
*/
void mfree (int numptrs, ...);

#endif

